// Livesplit ASL-plugin for American MacGee's Alice
// Version: 0.2.0

// Default state
state("alice", "vanilla")
{
	// CE addr:                006A006C
	int loading : "alice.exe", 0x2A006C;

	// CE addr:                    00689A1D
	// CE addr:                    00689A15
	string28 mapname: "alice.exe", 0x289A15;

	// CE addr:                  00BC7960
	string16 video: "alice.exe", 0x7C7960;
}

// EA Origin installer from "Alice: Madness Returns"
state("alice", "remastered")
{
	int loading : "alice.exe", 0x2D1DD0;

	// CE addr:                    006BB74D
	string28 mapname: "alice.exe", 0x2BB74D;

	// CE addr:                  012E3D74
	string16 video: "alice.exe", 0xEE3D74;
}

// director's cat installer of remastered
state("alice_hd", "remastered")
{
	int loading : "alice_hd.exe", 0x2D1DD0;

	// CE addr:                       006BB74D
	string28 mapname: "alice_hd.exe", 0x2BB74D;

	// CE addr:                     012E3D74
	string16 video: "alice_hd.exe", 0xEE3D74;
}

init
{
	vars.visited = new List<String>();
	vars.openingPlayed = false;
	vars.endingPlayed = false;

	print("Alice - init");
	print("Alice - ModuleMemorySize = " + modules.First().ModuleMemorySize);

	if (modules.First().ModuleMemorySize == 25677824) {
		print("Alice - game version detected: remastered");
		version = "remastered";
	}

	if (modules.First().ModuleMemorySize == 11788288) {
		print("Alice - game version detected: vanilla");
		version = "vanilla";
	}
}

start
{
	if (current.loading == 1 && current.mapname == "gvillage\\protocol\\1\\g_gamety") {
		print("Alice - start");

		vars.endingPlayed = false;
		vars.openingPlayed = false;
		vars.visited.Clear();
		
		vars.visited.Add("gvillage");
		return true;
	}

	return false;
}

isLoading 
{
	if (current.loading == 0) {
		return false;
	}
	
	return true;
}

split
{
	//print("current level: " + current.mapname);
	//print("previous level: " + old.mapname);
	//print("loading state: " + current.loading);
	//print("playing video: " + current.video);
	//print("visited maps list: " + vars.visited);

	// map change
	if (current.mapname != old.mapname) {

		string[] mapBeforeBackslashList = current.mapname.Split(new Char[] {'\\'}, 2, StringSplitOptions.None);
		string mapBeforeBackslash = mapBeforeBackslashList[0];

		string[] mapBeforeDollarList = mapBeforeBackslash.Split(new Char[] {'$'}, 2, StringSplitOptions.None);
		string mapBeforeDollar = mapBeforeDollarList[0];

		//print("current level: " + current.mapname);
		//print("previous level: " + old.mapname);
		//print("visited maps list: " + String.Join(", ", vars.visited.ToArray()));
		//print("visited maps number: " + vars.visited.Count);
		//print("mapBeforeBackslash:"  + mapBeforeBackslash);
		//print("mapBeforeDollar:"  + mapBeforeDollar);

		// logic for repeatable maps
		if (
			mapBeforeBackslash == "fortress1$fortress1_start1"
			||
			mapBeforeBackslash == "skool1$skool1_start1"
			||
			mapBeforeBackslash == "wforest$wforest_start1"
			||
			mapBeforeBackslash == "fortress1$fortress1_start2"
			||
			mapBeforeBackslash == "skool1$skool1_start2"
			||
			mapBeforeBackslash == "wforest$wforest_start2"
		) {
			if (vars.visited.Contains(mapBeforeBackslash)) {
				return false;
			}

			vars.visited.Add(mapBeforeBackslash);
			
			if (! vars.visited.Contains(mapBeforeDollar)) {
				vars.visited.Add(mapBeforeDollar);
			}

			//print("visited maps number: " + vars.visited.Count);

			print("Alice - split - " + mapBeforeBackslash);
			return true;
		}

		// logic for onetime maps
		if (vars.visited.Contains(mapBeforeDollar)) {
			return false;
		}

		vars.visited.Add(mapBeforeDollar);
		//print("visited maps number: " + vars.visited.Count);
		print("Alice - split - " + mapBeforeBackslash);
		return true;
	}

	// final video begins
	if (vars.endingPlayed == false && current.video == "video/ending.roq") {
		vars.endingPlayed = true;
		return true;
	}

	return false;
}

reset
{
	if (current.video == "video/opening.ro") {
		print("Alice - reset");

		vars.endingPlayed = false;
		vars.openingPlayed = false;
		vars.visited.Clear();

		return true;
	}

	return false;
}
